#include <math.h>
#include <stdlib.h>
#include<iostream.h>
#include "vecdefs.h"
#include "mvm.h"

MATRIX_double operator*(const MATRIX_double & A, const MATRIX_double & B)
{
int r_a = A.dim(0);
int c_a = A.dim(1);
int r_b = B.dim(0);
int c_b = B.dim(1);

if (c_a != r_b) { cerr << "Can't multiply them.";  }
else  {
MATRIX_double C(r_a,c_b,0);
for(int i=0;i<c_a;i++)
for(int j=0;j<r_b;j++){
C(i,j) = 0;
for(int k=0;k<c_a;k++)
 C(i,j) = C(i,j)+A(i,k)*B(k,j);
}
return(C);
}
} 

MATRIX_double operator+(const MATRIX_double & A, const MATRIX_double & B)
{
int r_a = A.dim(0);
int c_a = A.dim(1);
int r_b = B.dim(0);
int c_b = B.dim(1);

if (c_a != c_b || r_a != r_b ) { cerr << "Can't add them.";  }
else  {
MATRIX_double C(r_a,c_b,0);
for(int i=0;i<c_a;i++)
for(int j=0;j<r_b;j++){
C(i,j) = A(i,j) + B(i,j);
}
return(C);
}
} 



