


#include <iostream.h>
#include <stdlib.h>


#include "vecdefs.h"
#include MATRIX_H

// #include "systime.c"

// example function to zero-out a matrix:  illustrates how to pass
// matrixes by "reference" (modifiable), as opposed to by "value"
//
void foo(MATRIX_float *Aptr)
{
    MATRIX_float &A = *Aptr;

    A = (float) 0;      // equivalent to "Aptr->operator=(0);"
}

// example function to return MV_ColMats:  (returns matrix + scalar)
//
MATRIX_float fexample(const MATRIX_float A, float s)
{
    int M = A.size(0);
    int N = A.size(1);
    MATRIX_float B(M,N);

    for (int j=0; j<N; j++)
        for (int i=0; i<M; i++)
            B(i,j) = A(i,j) + s;

    return B;
}

MATRIX_float operator +(const MATRIX_float A, const MATRIX_float B)
{
    int M = A.size(0);
    int N = A.size(1);
    MATRIX_float C(M,N);

    for (int j=0; j<N; j++)
        for (int i=0; i<M; i++)
            C(i,j) = A(i,j) + B(i,j);

    return C;
}

MATRIX_float operator *(const MATRIX_float A, const MATRIX_float B)
{
    int M = A.size(0);
    int N = A.size(1);
    int R = B.size(0);
    int S = B.size(1);
    if (R != S) cerr << "wrong size\n";

    MATRIX_float C(M,S);

    for (int j=0; j<N; j++)
        for (int i=0; i<M; i++)
            C(i,j) = A(i,j) + B(i,j);

    return C;
}



int main()
{

    int i,j,N=3;

    MATRIX_float C;
    


    MATRIX_float A(N,N,0);
     
    cout << " A = " << endl;

    cout << A << endl;

    MATRIX_float B(N,N, 3);
     
     

    for (j=0; j<N; j++)
        for (i=0; i<N; i++)
        {
            A(i,j) = 100*i+j;
            B(i,j) =  - A(i,j);
        }

    MATRIX_float E(N,N) ;
    
    E = A + B;
    cout << " B = " << endl;
    cout <<  E << endl;

    MATRIX_float D(N,N,0);
    D = fexample(B,5.);
    cout << D << endl;

     
    return 0;
}
